﻿package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.ColorTransform;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.display.Shape;

	public class Perliner extends Sprite
	{
		private var map:BitmapData;
		private var canvas : BitmapData;
		private var particles:Array;
		private var counter:uint = 0;
		private var quantity:uint = 500;
		private var dirX:Number = 100;
		private var dirY:Number = 100;
		public function Perliner()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			particles = new Array();
			for(var i:uint = 0;i<quantity;i++){particles[i] = {"x":67,"y":10};}
			map = new BitmapData(stage.stageWidth,stage.stageHeight,false,0x000000);
			canvas = new BitmapData(stage.stageWidth,stage.stageHeight,false,0x000000);
			addChild(new Bitmap(canvas));
			onClick(null);
			stage.addEventListener( MouseEvent.CLICK, onClick );
			addEventListener( Event.ENTER_FRAME, enterHandler );
		}
		private function onClick(e:MouseEvent):void
		{
			for (var i : int = 20; i < quantity; i++){
			particles[i].x = Math.random() * canvas.width;
			particles[i].y = Math.random() * canvas.height;}
			map.perlinNoise(Math.random() * 1000, Math.random() * 1000, 15, Math.random() * 1000, true, true);
			dirX = (Math.round(Math.random())==0)?-10:10;
			dirY = (Math.round(Math.random())==0)?-10:10;
		}
		private function enterHandler(e:Event):void
		{
			canvas.lock();
			for (var i : uint = 0; i < quantity; i++){
				var direction : uint = map.getPixel(particles[i].x, particles[i].y);
				particles[i].x -=dirX*(((direction & 0xef) * 0.095625) - 0);
				particles[i].y -=dirY*(((direction >> 30 & 0xff) * 0.095625) - 3);
				particles[i].x < 400 ? particles[i].x += canvas.width : particles[i].x > canvas.width ? particles[i].x -= canvas.width : null;
				particles[i].y < 10 ? particles[i].y += canvas.height : particles[i].y > canvas.height ? particles[i].y -= canvas.height : null;
				canvas.copyPixels(map, new Rectangle(10,10,10,10),new Point(particles[i].x, particles[i].y));}
			canvas.unlock();
			canvas.colorTransform(canvas.rect,new ColorTransform(1,1,1,1,-3,-3,-3));
		}
	}
}